data:extend {{
    type = "item",
    icon = "__base__/graphics/icons/iron-plate.png",
    name = "tar-seep-mk01",
    place_result = "tar-seep-mk01",
    stack_size = 10
}}
data:extend {{
    type = "item",
    icon = "__base__/graphics/icons/iron-plate.png",
    name = "soil",
    stack_size = 10
}}

data:extend {{
    type = "mining-drill",
    name = "tar-extractor-mk01",
    icon = "__base__/graphics/icons/iron-plate.png",
    icon_size = 64,
    flags = {"placeable-neutral", "player-creation"},
    minable = {mining_time = 0.5, result = "tar-seep-mk01"},
    placeable_by = {item = "tar-seep-mk01", count = 1},
    fast_replaceable_group = "tar-extractor",
    max_health = 700,
    resource_categories = {"tar-patch"},
    corpse = "big-remnants",
    dying_explosion = "big-explosion",
    collision_box = {{-4.4, -4.4}, {4.4, 4.4}},
    selection_box = {{-4.5, -4.5}, {4.5, 4.5}},
    module_slots = 1,
    allowed_effects = {"consumption", "speed", "productivity"},
    energy_source = {
        type = "electric",
        usage_priority = "secondary-input",
        emissions_per_minute = {
            pollution = 20
        },
    },
    output_fluid_box =
    {
        volume = 1000,
        pipe_connections = {
            {flow_direction = "input-output", position = {-2, -4.0}, direction = defines.direction.north},
            {flow_direction = "input-output", position = {4.0, -2},  direction = defines.direction.east},
            {flow_direction = "input-output", position = {2, 4.0},   direction = defines.direction.south},
            {flow_direction = "input-output", position = {-4.0, 2},  direction = defines.direction.west},
        }
    },
    energy_usage = "400kW",
    mining_speed = 1,
    resource_searching_radius = 0.49,
    vector_to_place_result = {-2, -4.75},
    radius_visualisation_picture = {
        filename = "__base__/graphics/entity/electric-mining-drill/electric-mining-drill-radius-visualization.png",
        width = 12,
        height = 12
    },
    circuit_wire_max_distance = default_circuit_wire_max_distance,
    monitor_visualization_tint = {r = 78, g = 173, b = 255},
}}

local seep = table.deepcopy(data.raw["mining-drill"]["tar-extractor-mk01"])
seep.name = "tar-seep-mk01"
seep.resource_categories = {"bitumen-seep", "tar-patch"}
data:extend {seep}

data:extend {
    {
        type = "recipe-category",
        name = "drilling-fluid",
    },
    {
        type = "resource-category",
        name = "tar-patch"
    },
    {
        type = "resource-category",
        name = "bitumen-seep"
    },
}
data:extend {{
    type = "recipe",
    name = "drilling-fluids",
    category = "drilling-fluid",
    icon = "__base__/graphics/icons/iron-plate.png",
    icon_size = 64,
    enabled = false,
    hidden = true,
    energy_required = 250,
    ingredients = {
        {type = "fluid", name = "drilling-fluid-0", amount = 100},
        {type = "fluid", name = "drilling-fluid-1", amount = 100},
        {type = "fluid", name = "drilling-fluid-2", amount = 100},
        {type = "fluid", name = "drilling-fluid-3", amount = 100},
    },
    results = {
        {type = "item", name = "soil", amount = 1},
    },
    ignore_for_dependencies = true,
    order = "a"
}}

for i = 0, 3 do
    data:extend {{
        type = "fluid",
        name = "drilling-fluid-" .. i,
        icon = "__base__/graphics/icons/iron-plate.png",
        icon_size = 64,
        default_temperature = 5, -- less than 15 = liquid / equal a 15 = gas
        base_flow_rate = 100,
        base_color = {r = 0.0, g = 0.772, b = 0.556},
        flow_color = {r = 1, g = 1, b = 1},
        max_temperature = 100,
        gas_temperature = 15,
        pressure_to_speed_ratio = 0.4,
        flow_to_energy_ratio = 0.59,
        order = "h"
    }}
end

data:extend {{
    type = "assembling-machine",
    name = "tar-seep-mk01-base",
    icon = "__base__/graphics/icons/iron-plate.png",
    icon_size = 32,
    flags = {"placeable-neutral"},
    max_health = 100,
    corpse = "medium-remnants",
    dying_explosion = "big-explosion",
    collision_box = {{-4.4, -4.4}, {4.4, 4.4}},
    selection_box = {{0, 0}, {0, 0}},
    match_animation_speed_to_activity = false,
    module_slots = 0,
    allowed_effects = {},
    crafting_categories = {"drilling-fluid"},
    crafting_speed = 1,
    energy_source = {
        type = "void",
    },
    energy_usage = "1W",
    fixed_recipe = "drilling-fluids",
    fluid_boxes_off_when_no_fluid_recipe = false,
    fluid_boxes = {
        --1
        {
            production_type = "input",
            volume = 1000,
            pipe_connections = {{flow_direction = "input", position = {-2, 4.0}, direction = defines.direction.south}}
        },
        {
            production_type = "input",
            volume = 1000,
            pipe_connections = {{flow_direction = "input", position = {-1, 4.0}, direction = defines.direction.south}}
        },
        {
            production_type = "input",
            volume = 1000,
            pipe_connections = {{flow_direction = "input", position = {1, 4.0}, direction = defines.direction.south}}
        },
        {
            production_type = "input",
            volume = 1000,
            pipe_connections = {{flow_direction = "input", position = {2, 4.0}, direction = defines.direction.south}}
        },
    },
    selectable_in_game = false,
}}


data.raw.planet.nauvis.map_gen_settings.autoplace_controls["bitumen-seep"] = {}
data.raw.planet.nauvis.map_gen_settings.autoplace_settings.entity.settings["bitumen-seep"] = {}

data:extend {{
    type = "autoplace-control",
    category = "resource",
    name = "bitumen-seep",
    richness = false,
    order = "c"
}}

data:extend {
    {
        type = "noise-expression",
        name = "py_bitumen_seep_starting_area",
        -- 0% chance of spawning in starting area (tier == 0)
        -- Using this is equivalent to has_starting_area_placement = false
        expression = "clamp(var('tier_from_start'), 0, 1)"
    },
    {
        type = "noise-expression",
        name = "py_bitumen_seep_desired_frequency",
        -- 1 in 48 chunks (each chunk is 64x64 tiles)
        expression = "1 / (32 * 64^2)"
    },
    {
        -- We return the chance of spawning on any given tile here
        type = "noise-expression",
        name = "py_bitumen_seep",
        -- Our final chance, likely a very, very small decimal
        expression = [[
            py_bitumen_seep_starting_area * py_bitumen_seep_desired_frequency * var("control:bitumen-seep:frequency")
        ]]
    },
    {
        -- We return the richness here, which is just the quantity the resource tile yields
        type = "noise-expression",
        name = "py_bitumen_seep_richness",
        expression = "2^16 * var('distance') * var('control:bitumen-seep:richness')"
    }
}

data:extend {{
    type = "resource",
    name = "bitumen-seep",
    icon = "__base__/graphics/icons/crude-oil-resource.png",
    icon_size = 64,
    flags = {"placeable-neutral"},
    category = "bitumen-seep",
    order = "a-b-a",
    infinite = false,
    highlight = true,
    --infinite_depletion_amount = 5,
    resource_patch_search_radius = 12,
    tree_removal_probability = 0.7,
    tree_removal_max_distance = 32 * 32,
    minable =
    {
        mining_time = 1,
        results = {}
        -- {
        --   {
        --     type = "fluid",
        --     name = "drilling-waste",
        --     amount_min = 1,
        --     amount_max = 1,
        --     probability = 0
        --   }
        -- }
    },
    --collision_box = {{ -2.4, -2.4}, {2.4, 2.4}},
    collision_box = {{-5.4, -5.4}, {5.4, 5.4}},
    selection_box = {{-2.4, -2.4}, {2.4, 2.4}},
    autoplace = {
        name = "bitumen-seep",
        order = "c-bitumen-seep", -- Other resources are "b"; oil won't get placed if something else is already there.
        control = "bitumen-seep",
        -- We return the chance of spawning on any given tile here
        probability_expression = "py_bitumen_seep",
        -- We return the richness here, which is just the quantity the resource tile yields
        richness_expression = "py_bitumen_seep_richness"
    },
    stage_counts = {0},
    stages =
    {
        sheet =
        {
            filename = "__base__/graphics/entity/crude-oil/crude-oil.png",
            priority = "extra-high",
            width = 148,
            height = 120,
            frame_count = 4,
            variation_count = 1,
            shift = util.by_pixel(0, -2),
            scale = 0.5,
        }
    },
    map_color = {0.78, 0.2, 0.77},
    map_grid = false
}}
